import 'dart:async';
import 'dart:typed_data';

import 'package:daggerito/daggerito.dart';
import 'package:equatable/equatable.dart';
import 'package:example/utils.dart';
import 'package:example/view_model/capture_image_view_model.dart';
import 'package:example/widgets/card_image.dart';
import 'package:example/widgets/title_image.dart';
import 'package:example/widgets/widget_to_image.dart';
import 'package:flutter/material.dart';
import 'package:kohana/kohana.dart';
import 'package:rxdart/rxdart.dart';

// ignore: must_be_immutable
class CaptureImageExample extends StatefulView<CaptureImagesViewModel> {
// class CaptureImageExample extends StatelessWidget{
  final Component component;

  CaptureImageExample(this.component);

  @override
  Widget buildWidget(BuildContext context) => Scaffold(
      body: ListView(
        padding: EdgeInsets.all(16),
        children: [
          TitleWidget('Widgets'),
          WidgetToImage(
            builder: (key) {
              // this.$.key1 = key;
              $.addKey(KeyWithDescription(key, "prva"));

              return CardWidget(title: 'Title1', description: 'Description1');
            },
          ),
          WidgetToImage(
            builder: (key) {
              $.addKey(KeyWithDescription(key, "druga"));


              return CardWidget(title: 'Title2', description: 'Description2');
            },
          ),
          // WidgetToImage(
          //   builder: (key) {
          //     // this.$.key2 = key;
          //     // $.add(key);
          //
          //     return CardWidget(title: 'Title2', description: 'Description2');
          //   },
          // ),
          TitleWidget('Images'),
          Container(
            height: 300,
            child: Observer<List<Uint8List>>(
                stream: $.images,
                onSuccess: (c, images) => ListView.builder(
                      shrinkWrap: false,
                      itemBuilder: (c, index) => Utils.buildImage(images[index]),
                      itemCount: images.length,
                    )),
          )
        ],
      ),
      bottomSheet: Container(
        color: Theme.of(context).accentColor,
        padding: EdgeInsets.all(16),
        child: Container(
          width: double.infinity,
          child: RaisedButton(
            color: Colors.white,
            child: Text('Captureeeee'),
            onPressed: () async {
              // print("Ovo je capture");
              $.captureImages();
              // final bytes1 = await Utils.capture(this.$.key1);
              // final bytes2 = await Utils.capture(this.$.key2);
              //
              // setState(() {
              //   this.$.bytes1 = bytes1;
              //   this.$.bytes2 = bytes2;
              // });
            },
          ),
        ),
      ),
    );

  @override
  FieldsFactory<CaptureImagesViewModel> setup() {
    // print("Ovo je setup");
    // onMounted(() => Future.delayed(Duration(seconds: 3), () => print("Ovo je prva")));
    onMounted(() {
      disposeBag.addAll([
        $.images.listen((slike) {
          // print(["Ovo su slike;", slike]);
        }),
      ]);
    });
    return () => CaptureImagesViewModel();
  }
}
