part of 'db.dart';

class Box extends StatelessWidget {
  final String style;

  Box({
    this.style = '',
  });

  @override
  Widget build(BuildContext context) => Div(
        children: [
          Div(
            style: "bg-orange w-50 h-50 $style",
          ),
        ],
      );
}

class Lines extends StatelessWidget {
  final Widget child;
  final int height;
  int get half => height ~/ 2;

  Lines({
    this.child,
    this.height = 100,
  });

  @override
  Widget build(BuildContext context) => Div(
    style: "relative h-$height",
    children: [
      Div(
        style: "absolute h-$height object-center",
        child: Div(
          style: "w-$half h-$half bg-#F2D5BB",
        ),
      ),
      Div(
        style: "absolute flex flex-col h-$height",
        children: [
          Div(
            style: "flex-grow",
          ),
          Div(
            style: "h-1 bg-#7C8AA6",
          ),
          Div(
            style: "flex-grow",
          )
        ],
      ),
      Div(
        style: "absolute flex flex-row h-$height",
        children: [
          Div(
            style: "flex-grow",
          ),
          Div(
            style: "w-1 bg-#7C8AA6",
          ),
          Div(
            style: "flex-grow",
          )
        ],
      ),
      Div(
        style: "absolute h-$height object-center",
        child: child,
      ),
    ],
  );
}


class BoxWithLines extends StatelessWidget {
  final String style;

  BoxWithLines({
    this.style = '',
  });

  @override
  Widget build(BuildContext context) => Lines(child: Box(style: style));
}
