import 'package:example/db/db.dart';
import 'package:example/db/section_builder.dart';
import 'package:example/documentation/model/section.dart';
import 'package:example/documentation/widget/code_viewer.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:apply/apply.dart';

part 'documentation_widgets.dart';

part 'plugins/border_documentation.dart';

part 'plugins/border_radius_documentation.dart';

part 'plugins/flex_documentation.dart';

part 'plugins/grid_documentation.dart';

part 'plugins/transform_documentation.dart';

part 'plugins/typography_documentation.dart';

class DocumentationRepository {
  Future<List<Section>> allSections() async {
    var just = <Section>[
    ];
    var allSections = [
      ..._layout(),
      ..._sizing(),
      ..._spacing(),
      ..._typography(),
      ..._backgrounds(),
      ..._borders(),
      ..._transforms(),
      ..._animations(),
    ].where((element) => element != null).toList(growable: false);

    return just.isNotEmpty ? just : allSections;
  }

  Section test() => __typography();

  List<Section> _layout() => [
    _flex(),
    _grid(),
  ];
  List<Section> _sizing() => [

  ];
  List<Section> _spacing() => [

  ];

  List<Section> _typography() => [
    __typography(),
  ];

  List<Section> _backgrounds() => [

  ];
  List<Section> _borders() => [
    _border(),
    _borderRadius(),
  ];

  List<Section> _transforms() => [
    _transform(),
  ];

  List<Section> _animations() => [

  ];
}

var _$textStyle = "text-center text-white font-bold text-17";
var _$codeBoxStyle = "p-30 text-17 leading-20 tracking-34 object-center";
