part of 'documentation_repository.dart';

class _SectionPartWidget extends StatelessWidget {
  final Widget topWidget;
  final Widget bottomWidget;

  _SectionPartWidget({
    this.topWidget,
    this.bottomWidget,
  });

  @override
  Widget build(BuildContext context) => ClipRRect(
        borderRadius: BorderRadius.circular(25),
        child: Div(
          style: "flex flex-col bg-indigo-100",
          children: [
            Div(style: "p-16",
              child: topWidget,
            ),
            //bg-#2B2B2B
            bottomWidget ?? Container(),
          ],
        ),
      );
}

class _Box extends StatelessWidget {
  final String style;
  final String title;

  _Box({
    this.style = '',
    this.title = '',
  });

  @override
  Widget build(BuildContext context) => Div(
        style: "flex-grow object-center bg-indigo-300 border-indigo-600 h-85 ${_$textStyle} $style",
        children: [
          P(title ?? ""),
        ],
      );
}

class DBorderWidgets {
  static Widget get allSides => Div(
        style: "flex bg-indigo-50 h-100",
        children: [
          _Box(style: "border-none"),
          _Box(style: "border"),
          _Box(style: "border-3"),
          _Box(style: "border-5"),
          _Box(style: "border-10"),
        ],
      );
}
