part of '../documentation_repository.dart';

Section _flex() => SectionBuilder()
    .add(id: "flex", title: "Flex", description: "flex")
    .addPart(
      title: "Row",
      description: "desc 2",
      builder: (_) => _FlexRow(),
    )
    .addPart(
      title: "Column",
      description: "desc 2",
      builder: (_) => _FlexCol(),
    )
    .addPart(
      title: "Flex Wrap",
      description: "Utilities for controlling how flex items wrap.",
      builder: (_) => _FlexWrap(),
    )
    .addPart(
      title: "Flex Grow",
      description: "Utilities for controlling how flex items grow.",
      builder: (_) => _FlexGrow(),
    )
    .build();

class _FlexRow extends StatelessWidget {
  @override
  Widget build(BuildContext context) => _SectionPartWidget(
    topWidget: Div(
          style: "flex space-x-10",
          children: [
            _Box3(style: "w-75", title: "1"),
            _Box3(style: "w-75", title: "2"),
            _Box3(style: "w-75", title: "3"),
          ],
        ),
  );
}

class _FlexCol extends StatelessWidget {
  @override
  Widget build(BuildContext context) => _SectionPartWidget(
    topWidget: Div(
          style: "flex flex-col space-y-10 ",
          children: [
            _Box3(style: "", title: "1"),
            _Box3(style: "", title: "2"),
            _Box3(style: "", title: "3"),
          ],
        ),
  );
}

class _FlexWrap extends StatelessWidget {
  @override
  Widget build(BuildContext context) => _SectionPartWidget(
    topWidget: Div(
          style: "flex flex-wrap space-10",
          children: [
            _Box3(style: "w-100", title: "1"),
            _Box3(style: "w-100", title: "2"),
            _Box3(style: "w-100", title: "4"),
            _Box3(style: "w-200", title: "3"),
            _Box3(style: "w-100", title: "5"),
            _Box3(style: "w-210", title: "3"),
            _Box3(style: "w-100", title: "6"),
          ],
        ),
  );
}

class _FlexGrow extends StatelessWidget {
  @override
  Widget build(BuildContext context) => _SectionPartWidget(
        topWidget: Div(
          style: "flex space-x-12",
          children: [
            _Box3(style: "flex-grow", title: "1"),
            _Box3(style: "w-75", title: "2"),
            _Box3(style: "flex-grow", title: "3"),
          ],
        ),
        bottomWidget: Div(
          color: TWColors.fromHex("#21233f"),
          style: "${_$codeBoxStyle} text-17 leading-20 tracking-34 object-center",
          children: [
            CodeViewer(
              topics: Ranges.forPlugin("borderWidth"),
              code:
                  """Box(style: 'border-none', title: 'border none'),\nBox(style: 'border-1', title: 'border 1'),\nBox(style: 'border-2', title: 'border 2'),\nBox(style: 'border-4', title: 'border 4'),\nBox(style: 'border-8', title: 'border 8'),""",
              // width: 500,
            )
          ],
        ),
      );
}

class _Box3 extends StatelessWidget {
  final String style;
  final String title;

  _Box3({
    this.style = '',
    this.title = '',
  });

  @override
  Widget build(BuildContext context) => Div(
        style:
            "${_$textStyle} object-center bg-indigo-300 border-indigo-600 bg-fuchsia-400 h-60 rounded-10 text-20 $style",
        children: [
          P(title ?? ""),
        ],
      );
}
