part of '../documentation_repository.dart';

Section _grid() => SectionBuilder()
    .add(id: "grid", title: "Grid", description: "grid")
    .addPart(
      title: "Grid Template Columns",
      description: "desc 2",
      builder: (_) => _GridCols(),
    )
    .addPart(
      title: "Spanning columns",
      description: "desc 2",
      builder: (_) => _SpanningColumns(),
    )
    .addPart(
      title: "Grid Template Rows",
      description: "desc 2",
      builder: (_) => _GridRows(),
    )
    .addPart(
      title: "Spanning columns",
      description: "desc 2",
      builder: (_) => _SpanningRows(),
    )
    .build();


class _GridCols extends StatelessWidget {
  @override
  Widget build(BuildContext context) => _SectionPartWidget(
    topWidget: Div(
          style: "grid grid-cols-3 gap-16 h-230 ",
          children: [
            _Box2(style: "", title: "1"),
            _Box2(style: "", title: "2"),
            _Box2(style: "", title: "3"),
            _Box2(style: "", title: "4"),
            _Box2(style: "", title: "5"),
            _Box2(style: "", title: "6"),
          ],
        ),
  );
}

class _SpanningColumns extends StatelessWidget {
  @override
  Widget build(BuildContext context) => _SectionPartWidget(
    topWidget: Div(
          style: "grid grid-cols-3 gap-16 h-300 ",
          children: [
            _Box2(style: "", title: "1"),
            _Box2(style: "", title: "2"),
            _Box2(style: "", title: "3"),
            _Box2(style: "col-span-2", title: "4"),
            _Box2(style: "", title: "5"),
            _Box2(style: "", title: "6"),
            _Box2(style: "col-span-2", title: "7"),
          ],
        ),
  );
}

class _GridRows extends StatelessWidget {
  @override
  Widget build(BuildContext context) => _SectionPartWidget(
    topWidget: Div(
          style: "grid grid-rows-3 gap-16 h-270",
          children: [
            _Box2(style: "w-250", title: "1"),
            _Box2(style: "w-250", title: "2"),
            _Box2(style: "w-250", title: "3"),
            _Box2(style: "w-250", title: "4"),
            _Box2(style: "w-250", title: "5"),
            _Box2(style: "w-250", title: "6"),
          ],
        ),
  );
}

class _SpanningRows extends StatelessWidget {
  @override
  Widget build(BuildContext context) => _SectionPartWidget(
        topWidget: Div(
          style: "grid grid-rows-3 grid-flow-col gap-16 h-350",
          children: [
            _Box2(style: "row-span-3", title: "1"),
            _Box2(style: "col-span-2", title: "2"),
            _Box2(style: "bg-fuchsia-400 row-span-2 col-span-2", title: "3"),
          ],
        ),
        bottomWidget: Div(
          color: TWColors.fromHex("#21233f"),
          style: "${_$codeBoxStyle} text-17 leading-20 tracking-34 object-center",
          children: [
            CodeViewer(
              topics: Ranges.forPlugin("borderWidth"),
              code:
                  """Box(style: 'border-none', title: 'border none'),\nBox(style: 'border-1', title: 'border 1'),\nBox(style: 'border-2', title: 'border 2'),\nBox(style: 'border-4', title: 'border 4'),\nBox(style: 'border-8', title: 'border 8'),""",
              // width: 500,
            )
          ],
        ),
      );
}

class _Box2 extends StatelessWidget {
  final String style;
  final String title;

  _Box2({
    this.style = '',
    this.title = '',
  });

  @override
  Widget build(BuildContext context) => Div(
        style:
            "${_$textStyle} flex-grow object-center bg-indigo-300 border-indigo-600 h-85 bg-fuchsia-400 rounded-10 text-20 $style",
        children: [
          P(title ?? ""),
        ],
      );
}
