import 'package:example/documentation/model/section.dart';
import 'package:flutter/material.dart';
import 'package:pdf/widgets.dart' as pw;

class SectionBuilder {
  var counter = 0;
  Section section;

  SectionBuilder add({String id, String title, String description}) {
    section = Section(id, title: title, description: description);
    return this;
  }

  SectionBuilder addPart({
    String title,
    String description,
    WidgetBuilder builder,
    List<pw.TextSpan> text,
  }) {
    var sectionPart =
        SectionPart(index: counter++, title: title, description: description, builder: builder, text: text ?? []);
    section.parts.add(sectionPart);
    return this;
  }

  Section build() => section;
}
