import 'package:apply/apply.dart';
import 'package:example/demo/screens/layout_screen.dart';
import 'package:example/demo/widgets/demo_widgets.dart';
import 'package:flutter/material.dart';
import 'package:kohana/kohana.dart';

// ignore: must_be_immutable
class MainScreen extends StatefulView<String> {
  @override
  Widget buildWidget(BuildContext context) => Scaffold(
        drawer: Drawer(
          child: NavigationScreen(),
        ),
        body: Body(
          builder: (context) => Div(
            style: "overdflow-y-auto",
            child: Div(
              style: "grid grid-cols-2 sm:grid-cols-4 gap-12",
              children: [
                buildItem(title: "Layout"),
                buildItem(title: "Spacing"),
                buildItem(title: "Sizing"),
                buildItem(title: "Typography"),
                buildItem(title: "Backgrounds"),
                buildItem(title: "Borders"),
                buildItem(title: "Transforms"),
                buildItem(title: "Animations"),
              ],
            ),
          ),
        ),
      );

  Div buildItem({String title}) {
    return Div(
                style: "bg-gray object-center shadow-xl rounded-md h-80",
                children: [
                  P(title ?? ""),
                ],
              );
  }

  void layout(BuildContext context) {
    print("openDrawer");

    Navigator.of(context).push(MaterialPageRoute(
      builder: (context) => LayoutScreen(),
    ));
  }

  @override
  FieldsFactory<String> setup() => () => "Esselamu alejkum :)";
}
