import 'dart:async';
import 'dart:math';
import 'dart:typed_data';

import 'package:example/db/documentation_repository.dart';
import 'package:example/documentation/model/section.dart';
import 'package:example/documentation/view_model/section_view_model.dart';
import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:kohana/kohana.dart';
import 'package:meta/meta.dart';
import 'package:pdf/pdf.dart';
import 'package:pdf/widgets.dart' as pw;
import 'package:printing/printing.dart';
import 'package:rxdart/rxdart.dart';

part 'generate_pdf.dart';

// ignore: must_be_immutable
class DocumentationPdf extends StatefulView<_Fields> {
  final SectionViewModel model;

  DocumentationPdf({
    @required this.model,
  });

  @override
  Widget buildWidget(BuildContext context) => Scaffold(
        body: Observer<List<Section>>(
          stream: $.model.sections.delay(Duration(milliseconds: 500)),
          // stream: Stream.value([DocumentationRepository().test()]),
          onSuccess: (_, sections) => PdfPreview(
            initialPageFormat: PdfPageFormat.a4,
            maxPageWidth: 842,
            build: pdfFromSections(
              sections,
            ),
          ),
        ),
      );

  @override
  FieldsFactory<_Fields> setup() {
    return () => _Fields(model);
  }
}

class _Fields {
  final SectionViewModel model;

  _Fields(this.model);
}
