import 'package:example/db/documentation_repository.dart';
import 'package:example/documentation/model/section.dart';
import 'package:example/documentation/view_model/section_view_model.dart';
import 'package:flutter/material.dart';
import 'package:kohana/kohana.dart';
import 'package:apply/apply.dart';

// ignore: must_be_immutable
class GenerateContentPage extends StatefulView<_Fields> {
  final SectionViewModel model;

  GenerateContentPage({
    @required this.model,
  });

  final mode = 0;

  Widget testWidget(BuildContext context) => Div(
        style: "object-center-top",
        children: [
          DBorderWidgets.allSides,
        ],
      );

  @override
  Widget buildWidget(BuildContext context) => mode == 0
      ? Observer<List<Section>>(
          stream: $.model.sections,
          onSuccess: (context, parts) => ListView(
            shrinkWrap: true,
            // itemBuilder: (_, index) => ,
            // itemCount: parts.length,
            children: parts.map((e) => e.asWidget()).toList(growable: false),
          ),
          onWaiting: (c) => Text("cekam"),
          onError: (_, errorString) => Text(errorString),
        )
      : Div(
          style: "overflow-y-auto",
          child: buildTestWidget(),
        );

  Widget buildTestWidget() => DocumentationRepository().test().asWidget();

  // : testWidget(context);

  @override
  FieldsFactory<_Fields> setup() {
    return () => _Fields(model);
  }
}

class _Fields {
  final SectionViewModel model;

  _Fields(this.model);
}
