import 'package:dart_code_viewer/dart_code_viewer.dart';
import 'package:flutter/material.dart';
import 'package:google_fonts/google_fonts.dart';
import 'package:apply/apply.dart';

class CodeViewer extends StatelessWidget {
  final String code;
  final double height;
  final double width;
  final List<RegExp> topics;

  CodeViewer({
    this.code,
    this.height = 100,
    this.width,
    this.topics,
  });

  @override
  Widget build(BuildContext context) {
    var textStyle = TextStyle(fontSize: 20);
    var pair = P.getTextStyle(context);
    if (pair != null) {
      textStyle = pair.last;
    }
    // var topicsColor = TWColors.fromHex("#EFBB60");
    var topicsColor = TWColors.fromHex("#bef264");
    // var classColor = TWColors.fromHex("#e37af4");
    var classColor = TWColors.fromHex("#e37af4");
    // var stringsColor = TWColors.fromHex("#698857");
    var stringsColor = TWColors.fromHex("#bef264");
    // var baseColor = TWColors.fromHex("#A9B7C7");
    var baseColor = TWColors.fromHex("#22d3ee");
    // var punctuationColor = TWColors.fromHex("#A9B7C7");
    var punctuationColor = TWColors.fromHex("#22d3ee");
    return DartCodeViewer(
      code ?? "",
      showCopyButton: false,
      backgroundColor: Colors.transparent,
      topics: topics ?? [
        RegExp(r"rounded"),
        RegExp(r"border-\d{1,3}"),
      ],
      topicStyle: GoogleFonts.robotoMono( textStyle:textStyle.copyWith(color: topicsColor, fontWeight: FontWeight.bold)),
      classStyle: GoogleFonts.robotoMono( textStyle:textStyle.copyWith(color: classColor)),
      stringStyle: GoogleFonts.robotoMono( textStyle:textStyle.copyWith(color: stringsColor)),
      baseStyle: GoogleFonts.robotoMono( textStyle: textStyle.copyWith(color: baseColor)),
      punctuationStyle: GoogleFonts.robotoMono( textStyle:textStyle.copyWith(color: punctuationColor)),

    );
  }
}
