import 'package:flutter/material.dart';
import 'package:apply/apply.dart';

//
class AlignItemsExample extends StatelessWidget {
  @override
  Widget build(BuildContext context) => Scaffold(
        body: Column(
          children: [
            Expanded(
              child: Center(
                child: Container(
                  height: 300,
                  width: 300,
                  child: Div(
                    style: "relative",
                    children: [
                      Div(
                        style: "absolute",
                        child: Container(
                          height: 100,
                          width: 10,
                          color: Colors.purple,
                        ),
                      ),
                      Expanded(child: buildContainer()),
                    ],
                  ),
                ),
              ),
            ),
            Expanded(
              child: Row(
                crossAxisAlignment: CrossAxisAlignment.end,
                mainAxisAlignment: MainAxisAlignment.center,
                children: [
                  buildContainer(),
                  Offstage(
                    child: Container(
                      height: 100,
                      width: 75,
                      color: Colors.purple,
                    ),
                  ),
                  buildContainer(),
                  Div(
                    color: Colors.green,
                    style: "",
                    child: Text("Srediti margine i paddinge, visine i sirine"),
                  )
                ],
              ),
            )
          ],
        ),
      );

  Widget buildContainer({Color color}) => Padding(
        padding: const EdgeInsets.all(8.0),
        child: Container(
          height: 32,
          width: 32,
          color: color ?? Colors.blueAccent,
        ),
      );
}
