import 'package:flutter/material.dart';
import 'package:flutter/rendering.dart';
import 'package:flutter_staggered_grid_view/flutter_staggered_grid_view.dart';
import 'package:apply/apply.dart';

class GridExample extends StatelessWidget {
  @override
  Widget build(BuildContext context) => Scaffold(
        body: SingleChildScrollView(
          child: Column(
            mainAxisSize: MainAxisSize.min,
            children: [
              // Container(
              //   child: tailwindExample(),
              //   height: 400,
              // ),
              Container(
                child: buildStaggeredGridViewNew(),
                height: 350,
              ),
              Container(
                child: buildIdenticalGrid(),
                height: 350,
              ),
            ],
          ),
        ),
      );

  StaggeredGridView buildStaggeredGridViewOriginal() => StaggeredGridView.count(
        scrollDirection: Axis.horizontal,
        crossAxisCount: 3,
        mainAxisSpacing: 4.0,
        crossAxisSpacing: 4.0,
        padding: EdgeInsets.all(4.0),
        children: _children(),
        staggeredTiles: _staggeredTiles(),
      );

  List<StaggeredTile> _staggeredTiles() => [
        StaggeredTile.count(1, 1),
        StaggeredTile.extent(1, 60),
        // StaggeredTile.count(1, 1),
        StaggeredTile.count(1, 1),
        StaggeredTile.count(1, 2),
        StaggeredTile.count(1, 1),
        StaggeredTile.count(1, 1),
        StaggeredTile.count(1, 2),
      ];

  StaggeredGridView buildStaggeredGridViewNew() => StaggeredGridView.count(
        scrollDirection: Axis.vertical,
        crossAxisCount: 3,
        mainAxisSpacing: 4.0,
        crossAxisSpacing: 4.0,
        padding: EdgeInsets.all(4.0),
        children: _children(),
        staggeredTiles: _staggeredTiles(),
      );

  List<Widget> _children() => List.generate(
        7,
        (index) => Div(
          style: "h-50 border-2 rounded-5 object-center shadow-xl shadow-color-white",
          children: [
            P(
              "${index + 1}",
              style: "p-20 px-30 border-2 rounded-full text-center",
            )
          ],
        ),
      ).toList(growable: false);

  Widget buildIdenticalGrid() => Div(
        height: 400,
        style: "grid grid-rows-3 grid-flow-col gap-8",
        children: __children(),
      );

  List<Widget> __children() => [
        Div(
            style: " border-2 rounded-full m-8 object-center shadow-3xl shadow-color-white bg-orange",
            children: [P("1", style: "p-20 px-30 border-2 rounded-full text-center")]),
        Div(
          style: "border-2 rounded-xl w-20 h-50 object-center shadow-md shadow-color-yellow-300 bg-red",
          // children: [P("2", style: "p-20 px-30 border-2 rounded-full text-center w-0.8 h-0.8")],
        ),
        Div(
            style: " border-2 rounded-5 object-center shadow-xl shadow-color-white",
            children: [P("3", style: "p-20 px-30 border-2 rounded-full text-center")]),
        Div(
            style: "row-span-2 border-2 rounded-5 object-center shadow-xl shadow-color-white",
            children: [P("4", style: "p-20 px-30 border-2 rounded-full text-center")]),
        Div(
            style: " border-2 rounded-5 object-center shadow-xl shadow-color-white",
            children: [P("5", style: "p-20 px-30 border-2 rounded-full text-center")]),
        Div(
            style: " border-2 rounded-5 object-center shadow-xl shadow-color-white",
            children: [P("6", style: "p-20 px-30 border-2 rounded-full text-center")]),
        Div(
            style: "row-span-2 border-2 rounded-5 object-center shadow-xl shadow-color-white",
            children: [P("7", style: "p-20 px-30 border-2 rounded-full text-center")]),
      ];

  Widget tailwindExample() => Div(
        height: 400,
        style: "grid grid-rows-3 grid-flow-col gap-4",
        children: [
          Div(
              style: "row-span-3 border-2 rounded-5 object-center shadow-xl shadow-color-white",
              children: [P("1", style: "p-20 px-30 border-2 rounded-full text-center")]),
          Div(
              style: "col-span-2 border-2 rounded-5 object-center shadow-xl shadow-color-white",
              children: [P("2", style: "p-20 px-30 border-2 rounded-full text-center")]),
          Div(
              style: "row-span-2 col-span-2 border-2 rounded-5 object-center shadow-xl shadow-color-white",
              children: [P("3", style: "p-20 px-30 border-2 rounded-full text-center")])
        ],
      );
}
