import 'package:example/db/db.dart' as db;
import 'package:example/widgets/wrap_box.dart';
import 'package:flutter/material.dart';
import 'package:apply/apply.dart';
import 'package:apply/apply.dart';

import 'matrix_example.dart';

class TransformExample extends StatelessWidget {
  @override
  Widget build(BuildContext context) => Scaffold(
        body: Padding(
          padding: EdgeInsets.all(10.0),
          child: Div(
            style: "flex flex-col",
            children: [
              Div(
                style: "grid grid-cols-3 gap-5 w-405 h-250",
                children: db.Db.transforms.translate(),
              ),
              Div(
                style: "hidden",
                children: [
                  Transform(
                    //skew0.3
                    transform: Matrix4.identity()..rotateZ(3.14 / 12.0),
                    origin: Offset(50.0, 50.0),
                    child: Container(
                      height: 100.0,
                      width: 100.0,
                      color: Colors.blue,
                    ),
                  ),
                  Div(
                    style: "animate-slide animate-fadein relative w-100 h-100 bg-red",
                    child: Div(
                      style:
                          "shadow-md shadow-color-black -kew-y-6 kew-6 absolute bg-cover bg-asset-image-assets/images/house.jpg",
                      height: 100,
                      width: 100,
                    ),
                  ),
                  SizedBox(
                    height: 50,
                  ),
                  Div(
                    style: "flex justify-between",
                    children: [
                      Div(
                        style: "w-150 h-150 bg-green",
                        children: [
                          Div(
                            style: "w-100 h-100 bg-amber-300 translate-x-25 translate-y-5",
                          ),
                        ],
                      ),
                      Div(
                        style: "w-150 h-150 bg-green",
                        children: [
                          Div(
                            style: "w-100 h-100 bg-red",
                          ),
                        ],
                      ),
                    ],
                  ),
                  Div(
                    style: "flex justify-between bg-purple",
                    children: [
                      Container(
                        height: 150,
                        width: 150,
                        child: Center(
                          child: Div(
                            height: 100,
                            width: 100,
                            color: Colors.red,
                          ),
                        ),
                      ),
                      Div(
                        style: "object-left-bottom",
                        height: 150,
                        width: 150,
                        color: Colors.green,
                        child: Div(
                          style: "rotate-10 scale-70",
                          height: 100,
                          width: 100,
                          color: Colors.orange,
                        ),
                      ),
                    ],
                  ),
                  Div(
                    style: "flex flex-col",
                    children: [
                      WrapBox(
                        child: Box(
                          Matrix4Transform().translate(x: 25, y: 5).matrix4,
                          ".translate(x: 25)",
                        ),
                      ),
                      SizedBox(
                        height: 10,
                      ),
                      Div(
                        style: "object-left w-100 h-100 bg-pink",
                        children: [
                          Div(
                            style: "object-left w-100 h-100 bg-orange rotate-45",
                          )
                        ],
                      ),
                    ],
                  ),
                ],
              )
            ],
          ),
        ),
      );
}
