import 'package:example/demo/screens/main_screen.dart';
import 'package:example/di/app_component.dart';
import 'package:example/documentation/plugin_documentation_page.dart';
import 'package:example/examples/postpay_example.dart';
import 'package:flutter/material.dart';
import 'package:kohana/kohana.dart';
import 'package:rxdart/rxdart.dart';
import 'package:apply/apply.dart';

var appComponent = AppComponent();

void main() {
  // ApplyMediaQuery.size = Size(693,320);
  ApplyMediaQuery.size = Size(320,693);
  runApp(
    MaterialApp(
      debugShowCheckedModeBanner: false,
      home: _Holder(),
      // home: RootView(
      //   child: _Holder(),
      // ),
    ),
  );
}

const portrait = "h-693 w-320";
const landscape = "h-320 w-693";
var orientation = BehaviorSubject.seeded(portrait);

class RootView extends StatelessWidget {
  final Widget child;

  RootView({this.child});

  @override
  Widget build(BuildContext context) => Div(
        child: Scaffold(
          appBar: AppBar(
            backgroundColor: Colors.transparent,
            actions: [
              TextButton(
                  onPressed: () {
                    ApplyMediaQuery.size = Size(320,693);
                    orientation.add(portrait);
                  },
                  child: P(
                    "Portrait",
                    style: "text-white",
                  )),
              TextButton(
                  onPressed: () {
                    ApplyMediaQuery.size = Size(693,320);
                    orientation.add(landscape);
                  },
                  child: P(
                    "Landscape",
                    style: "text-white",
                  ))
            ],
          ),
          body: Observer(
            stream: orientation.stream,
            onSuccess: (_, style) => Div(
              style: "bg-green-400",
              child: Center(
                child: Div(
                  style: "$style",
                  child: child,
                ),
              ),
            ),
          ),
        ),
      );
}

class _Holder extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    // var child = AuthScreen();
    // var child = OverflowExample();
    // var child = ExampleOne();
    // var child = AlignItemsExample();
    // var child = PositionExample();
    // var child = TypographyExample();
    // var child = ButtonExample();
    // var child = ColorsExample();
    // var child = FontsAndSizingExample();
    // var child = ExampleHome();
    // var child = ExampleLayout();
    // var child = OriginExample();
    // var child = MatrixExample();
    // var child = AnimationExample();
    // var child = BorderExample();
    // var child = DocsStart();
    // var child = PdfExample();
    // var child = CodeViewExample();
    // var child = ScannerExample();
    // var child = CaptureImageExample(appComponent);
    // var child = TransformExample();
    // var child = SpacingExample();
    // var child = GridExample();
    // var child = PluginDocumentationPage(appComponent);
    // var child = MainScreen();
    var child = PostPayExample();
    return SafeArea(child: child);
  }
}
