import 'dart:typed_data';

import 'package:flutter/material.dart';
import 'package:flutter/rendering.dart';
import 'dart:ui' as ui;

class Utils {
  static Future<Uint8List> capture(GlobalKey key) async {
    if (key == null) return null;

    RenderRepaintBoundary boundary = key.currentContext.findRenderObject();
    final image = await boundary.toImage(pixelRatio: 3);
    final byteData = await image.toByteData(format: ui.ImageByteFormat.png);
    final pngBytes = byteData.buffer.asUint8List();

    return pngBytes;
  }





  static Widget buildImage(Uint8List bytes) => bytes != null ? Image.memory(bytes) : Container();
}


// extension on RenderRepaintBoundary{
//   Future<ui.Image> _toImage({ double pixelRatio = 1.0 }) {
//     // assert(!debugNeedsPaint);
//     final OffsetLayer offsetLayer = layer as OffsetLayer;
//     return offsetLayer.toImage(Offset.zero & size, pixelRatio: pixelRatio);
//   }
// }
