import 'dart:typed_data';
import 'dart:ui' as ui;

import 'package:after_layout/after_layout.dart';
import 'package:example/documentation/model/section.dart';
import 'package:flutter/material.dart';
import 'package:flutter/rendering.dart';
import 'package:kohana/kohana.dart';

class WidgetToImage2 extends StatefulView<GlobalKey> {
  final Function(Key key) builder;
  final Function(Key key) action;
  final SectionPart model;

  WidgetToImage2(this.model, {@required this.builder, this.action});

  @override
  Widget buildWidget(BuildContext context) => GestureDetector(
    onTap: _capturePng,
    child: RepaintBoundary(
          key: $,
          child: Center(
            child: builder($),
          ),
        ),
  );

  @override
  FieldsFactory<GlobalKey> setup() {
    // onMounted(() async {
    //   await Future.delayed(Duration(milliseconds: 200));
    //   // await Utils.capture($);
    //   await _capturePng();
    // });
    return () => GlobalKey();
  }

  Future<void> _capturePng() async {
    RenderRepaintBoundary boundary = $.currentContext.findRenderObject();
    ui.Image image = await boundary.toImage();
    ByteData byteData = await image.toByteData(format: ui.ImageByteFormat.png);
    Uint8List pngBytes = byteData.buffer.asUint8List();
    print(pngBytes);

    model.imageBytes = pngBytes;
    print("Uslikano");
  }
}

class WidgetToImage extends StatefulWidget {
  final Function(Key key) builder;
  final Function(Key key) action;

  const WidgetToImage({@required this.builder, this.action});

  @override
  _WidgetToImageState createState() => _WidgetToImageState();
}

class _WidgetToImageState extends State<WidgetToImage>
    with AfterLayoutMixin<WidgetToImage>, AutomaticKeepAliveClientMixin {
  final Key globalKey;

  _WidgetToImageState() : globalKey = GlobalKey();

  @override
  Widget build(BuildContext context) => RepaintBoundary(
        key: globalKey,
        child: Center(
          child: widget.builder(globalKey),
        ),
      );

  @override
  void afterFirstLayout(BuildContext context) async {
    await Future.delayed(Duration(milliseconds: 200));
    if (widget.action != null) {
      try {
        widget.action(globalKey);
      } catch (e) {
        print([this, this.widget.key, this.widget]);
      }
    } else {
      print("Nema funkcije");
    }
  }

  @override
  bool get wantKeepAlive => true;
}
