import 'dart:math';

import 'package:flutter/cupertino.dart';
import 'package:apply/core/framework.dart';
import 'package:apply/elements/div.dart';
import 'package:apply/elements/element_class.dart';
import 'package:apply/plugins/position/position.dart';

import 'package:apply/widgets/statefull_container.dart';


class PositionSecondImpl extends Position {
  final String value;

  PositionSecondImpl([this.value = "static"]);

  @override
  PositionSecondImpl createInstance(ElementClass elementClass) {
    return PositionSecondImpl(elementClass.value);
  }

  Widget handle(BuildContext context, Div element, WidgetBuilder wb) {
    if (value == "relative") {
      var plus = hideElementsFromDocumentDva(element,context);
      return StatefulContainer(
          plus: plus,
          child: Builder(
            builder: (c) => wb(c),
          ));
    }
    //kada funkcija u sustini nista neradi..
    return Builder(
      builder: (c) => wb(c),
    );
  }

  List<Widget> hideElementsFromDocumentDva(Div element, BuildContext context) {
    List<Widget> plus = [];
    var children = element.children;
    for (var i = 0; i < children.length; i++) {
      var child = children[i];
      if (child is Div) {
        Position childPosition = child.setOwnPlugins(context).ownPlugins.getPluginById("position");
        if (childPosition != null) {
          var value = childPosition.value;
          if (value == "absolute") {
            var absolutePositioned = children.removeAt(i);
            plus.add(
              Positioned(
                top: 60,
                child: absolutePositioned,
              ),
            );
          }
        }
      }
    }
    return plus;
  }
}
