import 'dart:math';

import 'package:flutter/cupertino.dart';
import 'package:apply/core/framework.dart';
import 'package:apply/core/plugin.dart';
import 'package:apply/core/range.dart';
import 'package:apply/elements/div.dart';
import 'package:apply/elements/element_class.dart';
import 'package:apply/plugins/position/position.dart';

import 'package:apply/widgets/statefull_container.dart';


class PositionThirdImpl extends Position {
  final String value;

  PositionThirdImpl([this.value = "static"]);

  @override
  PositionThirdImpl createInstance(ElementClass elementClass) {
    return PositionThirdImpl(elementClass.value);
  }

  Widget handle(BuildContext context, Div element, WidgetBuilder wb) {
    var children = element.children;
    if (value == "relative") {
     hideElementsFromDocument(children, context);
      return StatefulContainer(
          child: Builder(
            builder: (c) => wb(c),
          ));
    } else if (value == "absolute") {
      final containerState = context.findAncestorStateOfType<StatefulContainerState>();

      element.plugins.removeById("position");

      var double = Random().nextInt(100 - 1).toDouble();
      containerState?.addElement(
        Positioned(
          left: double,
          top: 100,
          child: element,
        ),
      );
      // print(["Ima li ?", containerState, double]);
      return Offstage();
    }

    //kada funkcija u sustini nista neradi..
    return Builder(
      builder: (c) => wb(c),
    );
  }

  void hideElementsFromDocument(List<Widget> children, BuildContext context) {
    for (var i = 0; i < children.length; i++) {
      var child = children[i];
      if (child is Div) {
        Position childPosition = child.setOwnPlugins(context).ownPlugins.getPluginById("position");
        if (childPosition != null) {
          var value = childPosition.value;
          if (value == "absolute") {
            children[i] = Offstage(
              child: child,
            );
          }
        }
      }
    }
  }
}
