const fs = require("fs");
const htmlparser2 = require("htmlparser2");

// const parser = new htmlparser2.Parser({
//     onopentag(name, attributes) {
//         /*
//          * This fires when a new tag is opened.
//          *
//          * If you don't need an aggregated `attributes` object,
//          * have a look at the `onopentagname` and `onattribute` events.
//          */
//         if (name === "script" && attributes.type === "text/javascript") {
//             console.log("JS! Hooray!");
//         }
//     },
//     ontext(text) {
//         /*
//          * Fires whenever a section of text was processed.
//          *
//          * Note that this can fire at any point within text and you might
//          * have to stich together multiple pieces.
//          */
//         console.log("-->", text);
//     },
//     onclosetag(tagname) {
//         /*
//          * Fires when a tag is closed.
//          *
//          * You can rely on this event only firing when you have received an
//          * equivalent opening tag before. Closing tags without corresponding
//          * opening tags will be ignored.
//          */
//         if (tagname === "script") {
//             console.log("That's it?!");
//         }
//     },
// });
// parser.write(
//     "Xyz <script type='text/javascript'>const foo = '<<bar>>';</ script>"
// );
// parser.end();

function parseDocument(content) {
  const parser = new htmlparser2.Parser({
    onopentag(name, attributes) {
      /*
       * This fires when a new tag is opened.
       *
       * If you don't need an aggregated `attributes` object,
       * have a look at the `onopentagname` and `onattribute` events.
       */
      if (name === "script" && attributes.type === "text/javascript") {
        console.log("JS! Hooray!");
      }
    },
    ontext(text) {
      /*
       * Fires whenever a section of text was processed.
       *
       * Note that this can fire at any point within text and you might
       * have to stich together multiple pieces.
       */
      console.log("-->", text);
    },
    onclosetag(tagname) {
      /*
       * Fires when a tag is closed.
       *
       * You can rely on this event only firing when you have received an
       * equivalent opening tag before. Closing tags without corresponding
       * opening tags will be ignored.
       */
      if (tagname === "template") {
        console.log("That's it?!");
      }
    },
  });
  parser.write(content);
  parser.end();
}

function parseFile(name) {
  fs.readFile("./" + name, "utf8", function (err, data) {
    if (err) {
      return console.log(err);
    }
    parseDocument(data);
  });
}

function main() {
  parseFile("example_home.dart.html");
}

main();
