import 'package:flutter_test/flutter_test.dart';
import 'package:apply/core/framework.dart';
import 'package:apply/elements/div.dart';
import 'package:apply/plugins/box_shadow.dart';

import '../dependencies/test_widget.dart';

void main() async {
  testWidgets('box shadow test', (WidgetTester tester) async {
    var div = Div(style: "shadow-color-red shadow-xl shadow-tl-lg");
    await TestWidget(child: div, tester: tester)();

    BoxShadowP shadowPlugin = div.plugins.getPluginById("boxShadow");

    var defaultValue = shadowPlugin.getValue() ?? shadowPlugin.defaultValue;

    var top = shadowPlugin.getValue("tl|tr|t") ?? shadowPlugin.noneValue;
    var bottom = shadowPlugin.getValue("bl|br|b") ?? defaultValue;
    var right = shadowPlugin.getValue("tr|br|r") ?? defaultValue;
    var left = shadowPlugin.getValue("tl|bl|l") ?? defaultValue;
    if (shadowPlugin != null) {
      print([
        "\n",
        "top: $top",
        "bottom: $bottom",
        "right: $right",
        "left: $left",
        "\n",
      ]);
    }
  });
}
