import 'package:flutter/material.dart';
import 'package:flutter_staggered_grid_view/flutter_staggered_grid_view.dart';
import 'package:flutter_test/flutter_test.dart';
import 'package:apply/core/framework.dart';
import 'package:apply/elements/div.dart';
import 'package:apply/plugins/grid.dart';
import 'package:apply/apply.dart';

import '../dependencies/test_widget.dart';

void main() async {
  testWidgets('grid test', (WidgetTester tester) async {
    var div = Div(
      style: "grid grid-cols-3 grid-flow-row",
      children: __children(),
    );

    var context = await TestWidget(child: div, tester: tester)();

    GridP gridPlugin = div.plugins.getPluginById("grid");
    if (gridPlugin != null) {
      // print(gridPlugin.createConfig(div, context).debug());
    }
  });
}


List<Widget> __children() => [
  Div(
      style: "h-50 border-2 rounded-5 object-center shadow-xl shadow-color-white",
      children: [P("1", style: "p-20 px-30 border-2 rounded-full text-center")]),
  Div(
      style: " border-2 rounded-5 object-center shadow-xl shadow-color-white",
      children: [P("2", style: "p-20 px-30 border-2 rounded-full text-center")]),
  Div(
      style: " border-2 rounded-5 object-center shadow-xl shadow-color-white",
      children: [P("3", style: "p-20 px-30 border-2 rounded-full text-center")]),
  Div(
      style: "row-span-2 border-2 rounded-5 object-center shadow-xl shadow-color-white",
      children: [P("4", style: "p-20 px-30 border-2 rounded-full text-center")]),
  Div(
      style: " border-2 rounded-5 object-center shadow-xl shadow-color-white",
      children: [P("5", style: "p-20 px-30 border-2 rounded-full text-center")]),
  Div(
      style: " border-2 rounded-5 object-center shadow-xl shadow-color-white",
      children: [P("6", style: "p-20 px-30 border-2 rounded-full text-center")]),
  Div(
      style: "row-span-2 border-2 rounded-5 object-center shadow-xl shadow-color-white",
      children: [P("7", style: "p-20 px-30 border-2 rounded-full text-center")])
  ,
];


extension on List<StaggeredTile>{
  String debug(){
    var buffer = StringBuffer();
    for(var tile in this){
      buffer.writeln([tile.mainAxisCellCount, tile.crossAxisCellCount, tile.mainAxisExtent, tile.fitContent]);
    }

    return buffer.toString();
  }
}
