class _DebugRegex {
  final bool hasMatch;
  final List<RegExpMatch> allMatches;

  _DebugRegex._([this.hasMatch, this.allMatches = const []]);

  factory _DebugRegex({String input, String regex}) {
    final _roundedRegex = RegExp(regex);

    var allMatches = _roundedRegex.allMatches(input).toList(growable: false);
    var hasMatch = allMatches.length > 0;

    return _DebugRegex._(hasMatch, allMatches);
  }

  String debugMatches() {
    for (var match in allMatches) {
      print("================");
      print(match.group(1));
      print("================");
    }

    return "";
  }

  @override
  String toString() {
    return '_DebugRegex{hasMatch: $hasMatch, allMatches: ${debugMatches()}';
  }
}
